//+------------------------------------------------------------------+
//|                                                  WeeklyPivot.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Black
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_color6 Red
#property indicator_color7 Red
#property indicator_color8 Red
//---- input parameters

//---- buffers
double PBuffer[];
double R1Buffer[];
double M3Buffer[];
double R2Buffer[];
double M4Buffer[];
double R3Buffer[];
double M5Buffer[];
double S1Buffer[];
string Pivot="WeeklyPivotPoint",WRes1="W_R 1", WM3="W_M 3";
string WRes2="W_R 2", WM4="W_M 4", WRes3="W_R 3", WM5="W_M 5" ,WSup1="W_S 1";
int fontsize=10;
double P,R1,M3,R2,M4,R3,M5,S1;
double last_week_high, last_week_low, this_week_open, last_week_close;

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

   ObjectDelete("WeeklyPivot");
   ObjectDelete("WRes1");
   ObjectDelete("WM3");
   ObjectDelete("WRes2");
   ObjectDelete("WM4");
   ObjectDelete("WRes3");
   ObjectDelete("WM5");  
   ObjectDelete("WSup1"); 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;


//---- indicator line
   SetIndexStyle(0,DRAW_LINE,0,2,Magenta);
   SetIndexStyle(1,DRAW_LINE,0,2,Red);
   SetIndexStyle(2,DRAW_LINE,0,2,Red);
   SetIndexStyle(3,DRAW_LINE,0,2,Red);
   SetIndexStyle(4,DRAW_LINE,0,2,Red);
   SetIndexStyle(5,DRAW_LINE,0,2,Red);
   SetIndexStyle(6,DRAW_LINE,0,2,Red);
   SetIndexStyle(7,DRAW_LINE,0,2,Red);
   SetIndexBuffer(0,PBuffer);
   SetIndexBuffer(1,R1Buffer);
   SetIndexBuffer(2,M3Buffer);
   SetIndexBuffer(3,R2Buffer);
   SetIndexBuffer(4,M4Buffer);
   SetIndexBuffer(5,R3Buffer);
   SetIndexBuffer(6,M5Buffer);
   SetIndexBuffer(7,S1Buffer);


//---- name for DataWindow and indicator subwindow label
   
   SetIndexLabel(0,"Weekly Pivot");
   SetIndexLabel(1,"Weekly R1");
   SetIndexLabel(2,"Weekly M3");
   SetIndexLabel(3,"Weekly R2");
   SetIndexLabel(4,"Weekly M4");
   SetIndexLabel(5,"Weekly R3");
   SetIndexLabel(6,"Weekly M5");
   SetIndexLabel(7,"Weekly S1");

//----
   SetIndexDrawBegin(0,1);
//----
 

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int counted_bars=IndicatorCounted();

   int limit, i;
//---- indicator calculation
if (counted_bars==0)

   if(counted_bars<0) return(-1);

   limit=(Bars-counted_bars)-1;


for (i=limit; i>=0;i--)
{ 


   // Monday
	if ( 1 == TimeDayOfWeek(Time[i]) && 1 != TimeDayOfWeek(Time[i+1]) )
	{
		last_week_close = Close[i+1];
		this_week_open = Open[i];

		// WeeklyPivot
		P = (last_week_high + last_week_low + last_week_close) / 3;

   R1 = (2*P)-last_week_low;
   S1 = (2*P)-last_week_high;
   R2 = P-S1+R1;
   M3 = (P+R1)/2;
   R3 = (2*P)+(last_week_high-(2*last_week_low));
   M4 = (R2+R1)/2;
   M5 = (R3+R2)/2; 
  
   last_week_low=Low[i]; last_week_high=High[i];

	ObjectMove("WeeklyPivot", 0, Time[i],P);
   ObjectMove("WRes1", 0, Time[i],R1);
   ObjectMove("WM3", 0, Time[i],M3);
   ObjectMove("WRes2", 0, Time[i],R2);
   ObjectMove("WM4", 0, Time[i],M4);
   ObjectMove("WRes3", 0, Time[i],R3);
   ObjectMove("WM5", 0, Time[i],M5);
   ObjectMove("WSup1", 0, Time[i],S1);

}   
    
    last_week_high = MathMax(last_week_high, High[i]);
 	 last_week_low = MathMin(last_week_low, Low[i]);   
    PBuffer[i]=P;
    R1Buffer[i]=R1;
    M3Buffer[i]=M3;
    R2Buffer[i]=R2;
    M4Buffer[i]=M4;
    R3Buffer[i]=R3;
    M5Buffer[i]=M5;
    S1Buffer[i]=S1;

}

//----
   return(0);
  }
//+------------------------------------------------------------------+